diff --git a/Unicode/ustring.c b/Unicode/ustring.c
index f1441a3bea..b4a498e8c3 100644
--- a/Unicode/ustring.c
+++ b/Unicode/ustring.c
@@ -655,18 +655,21 @@ char *u2utf8_copy(const unichar_t *ubuf) {
 
 char *u2utf8_copyn(const unichar_t *ubuf,int len) {
 /* Make a utf8 string copy of unichar string ubuf[0..len] */
-    char *utf8buf, *pt;
+    char *utf8buf, *pt, *pt2;
 
     if ( ubuf==NULL || len<=0 || (utf8buf=pt=(char *)malloc(len*6+1))==NULL )
 	return( NULL );
 
-    while ( (pt=utf8_idpb(pt,*ubuf++,0)) && --len );
-    if ( pt ) {
-	*pt = '\0';
-	return( utf8buf );
-    }
-    free( utf8buf );
-    return( NULL );
+    while ( (pt2=utf8_idpb(pt,*ubuf++,0)) && --len )
+	pt = pt2;
+
+    if ( pt2 )
+	pt = pt2;
+    else
+	TRACE("u2utf8_copyn: truncated on invalid char 0x%x\n", ubuf[-1]);
+
+    *pt = '\0';
+    return( utf8buf );
 }
 
 int32 utf8_ildb(const char **_text) {
diff --git a/fontforgeexe/fontview.c b/fontforgeexe/fontview.c
index ed92b9d9e1..214bec9622 100644
--- a/fontforgeexe/fontview.c
+++ b/fontforgeexe/fontview.c
@@ -5868,7 +5868,7 @@ static void FVExpose(FontView *fv,GWindow pixmap, GEvent *event) {
 		    use_utf8 = true;
 			*pt = '\0'; // We terminate the string in case the appendage (?) fails.
 		    pt = utf8_idpb(pt,uni,0);
-		    if (pt) *pt = '\0'; else fprintf(stderr, "Invalid Unicode alert.\n");
+		    if (pt) *pt = '\0'; else TRACE("Invalid Unicode alert.\n");
 		} else {
 		    char *pt = strchr(sc->name,'.');
 		    buf[0] = '?';
diff --git a/inc/basics.h b/inc/basics.h
index 366f921c44..7f3390f7ef 100644
--- a/inc/basics.h
+++ b/inc/basics.h
@@ -67,9 +67,9 @@ typedef uint32 unichar_t;
 /* A macro to print a string for debug purposes
  */
 #ifndef NDEBUG
-#define TRACE(...) printf(__VA_ARGS__)
+#define TRACE(...) fprintf(stderr, __VA_ARGS__)
 #else
-#define TRACE(...)
+#define TRACE(...) while(0)
 #endif
 
 /* assert() with an otherwise unused variable
